{#
Template for the results page, that is invoked as a consequence of
a search for music issued by a user via the "listen to a song" page.
It displays all songs that matched the users query and allows the user
to play any of that songs via the built-in html audio player.
Author: Jero Schäfer
Last modified: 22.06.2020
#}
{% extends "base.html" %}
{% import "form_styling_macro.html" as macros %}

{# Add custom style for the album covers #}
{% block styles %}
    {{ super() }}
    <style>
        .bd-placeholder-img {
            font-size: 24px;
            text-align: center;
            display: flex;
            height: 225px;
            width: auto;
            justify-content: center;
            align-items: center;
            margin: 0 auto;
            -webkit-user-select: none;
            -moz-user-select: none;
            -ms-user-select: none;
            user-select: none;
        }

        @media (min-width: 768px) {
            .bd-placeholder-img-lg {
                font-size: 3.5rem;
            }
        }

        .music-icon {
            display: flex;
            justify-content: center;
            align-items: center;
            font-size: 24px;
            background-color: gray;
            border-radius: 25px;
            padding: 10px;
        }
    </style>
{% endblock %}


{% block page_content %}
    <main role="main">
        <section class="jumbotron text-center">
            <div class="container">
                <h1 class="jumbotron-heading">Search Results</h1>
                <p class="lead text-muted">
                    See what songs match your query. If you want to hear them, just click on the play button.
                </p>
                <div>
                    <p>
                    <form class="form" method="post" role="form">
                        {{ form.csrf_token() }}
                        <div class="form-group row">
                            <div class="col-sm-2">
                                {{ macros.render_field(form.select) }}
                            </div>
                            <div class="col-sm-10">
                                {{ macros.render_field(form.search) }}
                            </div>
                        </div>
                        {{ macros.render_field(form.submit) }}
                    </form>
                    </p>
                </div>
            </div>
        </section>

        {# List all the search results #}
        <div class="album py-5 bg-light">
            <div class="container">
                <div class="row">

                    {% for result in results %}
                        <div class="col-md-4">
                            <div class="card mb-4 shadow-sm">
                                {# Album cover if present else default image #}
                                {% if result.cover %}
                                    <img class="bd-placeholder-img card-img-top" src="{{ result.cover }}"/>
                                {% else %}
                                    <div class="bd-placeholder-img card-img-top">
                                        <div class="music-icon">
                                            <i class="fas fa-music fa-3x"></i>
                                        </div>
                                    </div>
                                {% endif %}

                                {# Display metadata here and audio controls #}
                                <div class="card-body">
                                    <p class="card-text">{{ result.title }}, {{ result.artist }}</p>
                                    <div class="d-flex justify-content-between align-items-center">
                                        <audio controls>
                                            <source src="{{ result.hash | to_url }}"/>
                                            Your browser does not support the <code>audio</code> element.
                                        </audio>
                                    </div>
                                </div>
                            </div>
                        </div>
                    {% endfor %}

                </div>
            </div>
        </div>

    </main>

{% endblock %}